unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Buttons, StdCtrls, Menus;

type
  TForm2 = class(TForm)
    TiliEditBox1: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    TiliNro2: TEdit;
    TiliNimi2: TEdit;
    Alv1: TComboBox;
    AlvPros1: TEdit;
    Ok4: TButton;
    Cancel4: TButton;
    EditBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label7: TLabel;
    TosNro1: TEdit;
    Pvm1: TEdit;
    Selite1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    EditGrid1: TStringGrid;
    EditEro1: TEdit;
    TiliEdit1: TComboBox;
    EditMenu1: TPopupMenu;
    DelRow1: TMenuItem;
    VatBox1: TGroupBox;
    VatGrid1: TStringGrid;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    VahVero1: TEdit;
    MaksVero1: TEdit;
    VahVero2: TEdit;
    MaksVero2: TEdit;
    AddRivi1: TMenuItem;
    RiviUp1: TMenuItem;
    RiviDown1: TMenuItem;
    procedure TiliEditBox1Enter(Sender: TObject);
    procedure EditGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure EditGrid1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure EditGrid1Exit(Sender: TObject);
    procedure EditGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure EditGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Pvm1Click(Sender: TObject);
    procedure Pvm1KeyPress(Sender: TObject; var Key: Char);
    procedure Pvm1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UusiCell(C, R: Integer);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure DelRow1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TiliEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TiliEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure TiliEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TiliEdit1Enter(Sender: TObject);
    procedure TiliEdit1DropDown(Sender: TObject);
    procedure TiliEdit1Exit(Sender: TObject);
    procedure Ok4Click(Sender: TObject);
    procedure Cancel4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Alv1Change(Sender: TObject);
    procedure Pvm1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AddRivi1Click(Sender: TObject);
    procedure RiviDown1Click(Sender: TObject);
    procedure RiviUp1Click(Sender: TObject);
  private
    { Private declarations }
    EroFlag, TiliEditKesken, CellMuuntoKesken: Boolean;
    EditSum: Integer;
    procedure ExitCell;
    procedure TiliEditShow(C, R: Integer);
  public
    { Public declarations }
    procedure EditBoxStart(Uusi: Boolean);
    procedure PutTosite;
    procedure GridSumma;
    procedure ShowMe(Control: TControl);
  end;

var
  Form2: TForm2;
  MaxTiliRow: Integer;

implementation

uses Unit1, SubRut, comctrls;

{$R *.DFM}

{ Form2 nyttn }
procedure TForm2.ShowMe(Control: TControl);
var
  Ix: Integer;
begin
  if Visible
  then Hide
  else
  for Ix := 0 to ControlCount - 1 do
  if Controls[Ix] is TGroupBox then
  begin
    if Control = Controls[Ix] then
    begin
      ClientHeight := Control.Height;
      ClientWidth := Control.Width;
      Left := ((Form1.Width - Width) div 2) + Form1.Left;
      Top := ((Form1.Height - Height) div 2) + Form1.Top;
      Control.Left := 0;
      Control.Top := 0;
      Show;
      Control.Show;
    end
    else Controls[Ix].Hide;
  end;
end;

{ Alv-prosentin editointi sallitaan vain, jos on valittu alv-tili }
procedure TForm2.TiliEditBox1Enter(Sender: TObject);
begin
  AlvPros1.Enabled := Alv1.ItemIndex in [1..3];
  if not AlvPros1.Enabled then AlvPros1.Text := '';
end;

procedure TForm2.EditGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if Col > 0 then
  begin
    EditGrid1.Canvas.FillRect(Rect);
    EditGrid1.Canvas.TextOut(Rect.Right - EditGrid1.Canvas.TextWidth(EditGrid1.Cells[Col, Row]) - 2,
    Rect.Top, EditGrid1.Cells[Col, Row]);
  end;
end;

{ tositteen editointia; editoitava cell muuttunut
  Col, Row on uusi cell, EditGrid1.Cell, .Row on nykyinen cell}
procedure TForm2.EditGrid1SelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  if not CellMuuntoKesken then UusiCell(Col, Row);
  CanSelect := True;
end;

procedure TForm2.EditGrid1Exit(Sender: TObject);
begin
  ExitCell;
end;

procedure TForm2.ExitCell;
var
  ApuI: Integer;
begin
  with EditGrid1 do
  if (Row > 0) and (Col > 0) then
  begin
    ApuI := SumTxtToInt(Cells[Col, Row]);
    if (ApuI <> 0) then            // or (Length(Cells[Col xor 3, Row]) = 0) then
    EditGrid1.Cells[EditGrid1.Col, EditGrid1.Row] := Format('%.2f', [ApuI/100]);
    // if ApuI <> 0 then
    GridSumma;
  end;
end;

{ tositteen editointia; lasketaan vientien summat }
procedure TForm2.GridSumma;
var
  Ix, Iy: Integer;
  Sum: array[1..2] of Integer;
begin
  Sum[1] := 0;
  Sum[2] := 0;
  for Ix := 1 to 2 do
  for Iy := 1 to EditGrid1.RowCount - 1 do
  Inc(Sum[Ix], SumTxtToInt(EditGrid1.Cells[Ix, Iy]));
  EditSum := Sum[1];
  EditEro1.Tag := Sum[2]-Sum[1];
  EditEro1.Text := Format('%.2f', [EditEro1.Tag/100]);
  EroFlag := Sum[1] <> Sum[2];
end;

procedure TForm2.EditGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (EditGrid1.Row > (MaxTiliRow + 1))
    or ((EditGrid1.Col > 0) and (EditGrid1.Row > MaxTiliRow)) then Key := #0;
  if EditGrid1.Col in [1..2] then
  begin
    if Key in[',', '0'..'9'] then
    begin
      if (EditGrid1.Col = 1) then EditGrid1.Cells[2, EditGrid1.Row] := ''
      else if (EditGrid1.Col = 2) then EditGrid1.Cells[1, EditGrid1.Row] := '';
    end
    else if Key >= ' ' then Key := #0;
  end;
  if Key = #13 then
  begin
    if (EditGrid1.Row <= MaxTiliRow) and (MaxTiliRow < (EditGrid1.RowCount - 1)) then
    begin
      EditGrid1.Row := MaxTiliRow + 1;
      EditGrid1.Col := 0;
    end;
    ExitCell;
  end
  else with EditGrid1 do
  if (Key = Char(VK_ESCAPE)) and (Objects[Col, Row] <> nil) then
  Cells[Col, Row] := Format('%.2f', [Integer(Objects[Col, Row])/100]);
end;

procedure TForm2.EditGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  C, R: Integer;
begin
  if Button = mbRight then
  begin
    EditGrid1.MouseToCell(X, Y, C, R);
    if (R >= 0) and (R < EditGrid1.RowCount) then
    begin
      EditGrid1.Col := 1;
      CellMuuntoKesken := True;
      EditGrid1.Row := R;
      CellMuuntoKesken := False;
      Form1.ShowPopup(EditGrid1, EditMenu1, Point(X, Y));
    end;  
  end;
end;

procedure TForm2.Pvm1Click(Sender: TObject);
begin
  TEdit(Sender).SelLength := 1;
end;

procedure TForm2.Pvm1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then Key := 0;
end;

{ pivmrkentn editointi tositteen editoinnissa tai uuden kirjanpidon avauksessa }
procedure TForm2.Pvm1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    //EditGrid1KeyPress(Sender, Key);
    EditGrid1.SetFocus;
    UusiCell(0, 1);
    Key := #0;
  end;
  if not (Key in ['0'..'9']) then Key := #0;
end;

procedure TForm2.Pvm1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Form1.Pvm1KeyUp(Sender, Key, Shift);
end;

procedure TForm2.EditBoxStart(Uusi: Boolean);
begin
  GridSumma;
  ClientHeight := EditBox1.Height;
  ClientWidth := EditBox1.Width;
  CellMuuntoKesken := True;
//  ShowMe(EditBox1);
  EditGrid1.Col := 0;
  EditGrid1.Row := 1;
  TiliEditShow(0, 1);
  CellMuuntoKesken := False;
  if Uusi
  then TosNro1.Enabled := Form1.Paivakirja.Items[0].Count = 0
  else TosNro1.Enabled := Form1.Paivakirja.Items[0].Count <= 1;
  Pvm1.SetFocus;
  Pvm1.SelStart := 0;
  Pvm1.SelLength := 1;
  TiliEdit1.Items.Assign(Accounts1);
end;

procedure TForm2.TiliEditShow(C, R: Integer);
begin
  with EditGrid1 do
  begin
    TiliEdit1.Top := Top + (R - TopRow + 1) * (DefaultRowHeight + GridLineWidth) + 2;
    TiliEdit1.Text := Cells[C, R];
    TiliEdit1.Tag := R;
    TiliEdit1.Show;
  end;
end;

procedure TForm2.UusiCell(C, R: Integer);
var
  ApuI: Integer;
begin
  if EditBox1.Visible then
  with EditGrid1 do
  begin
    { tilinumeron ja nimen sarake }
    if (Col = 0) and (Row > 0) and TiliEdit1.Visible
    and (TiliEdit1.Top = Top + (Row - TopRow + 1) * (DefaultRowHeight + GridLineWidth) + 2)
    then
    begin   { poistutaan cell'ist }
      ApuI := StringIndexL(Accounts1, TiliEdit1.Text);
      if ApuI >= 0 then
      begin
        Cells[Col, Row] := Accounts1[ApuI];
      end
      else Cells[Col, Row] := '';
      TiliEdit1.Hide;
      SetFocus;
    end;
    if (C = 0) and (R > 0) then
    begin   { tullaan uuteen cell'iin }
      TiliEditShow(C, R);
      TiliEdit1.SetFocus;
    end;

  { valuuttasarakkeet }
    { poistutaan vanhasta }
    if (Col > 0) and (Row > 0) then ExitCell;
    { tullaan uuteen }
    if (C > 0) and (R > 0) then Objects[C, R] := Pointer(SumTxtToInt(Cells[C, R]));
  end;
end;

{ tositteen editointia, kertn pivkirjan nodesta tiedot editointiruutuun }
procedure TForm2.PutTosite;
var
  Ix, Iy, ApuI: Integer;
  ApuS: String;
begin
  Ix := 1;
  ApuI := StrToIntDef(StrFromStr(EditNode.Text, '[', ']', Ix), -1);
  ApuS := StrFromStr(EditNode.Text, ' ', ':', Ix);
  if (ApuI >= 0) and (Length(ApuS) = 10) then
  begin
    TosNro1.Text := IntToStr(ApuI);
    Pvm1.Text := ApuS;
    Selite1.Text := Trim(StrFromStr(EditNode.Text, '-', #0, Ix));
    with EditGrid1 do
    for Ix := 0 to ColCount - 1 do
    for Iy := 1 to RowCount - 1 do
      Cells[Ix, Iy] := '';
    MaxTiliRow := 0;
    if EditNode.Count > 0 then
    for Iy := 0 to EditNode.Count - 1 do
    begin
      Ix := 1;
      ApuI := SumTxtToInt(EditNode.Item[Iy].Text);    // vientisumma
      if ApuI < 0
      then EditGrid1.Cells[2, Iy + 1] := Format('%.2f', [-ApuI/100])
      else EditGrid1.Cells[1, Iy + 1] := Format('%.2f', [ApuI/100]);
      ApuS := StrFromStr(EditNode.Item[Iy].Text, ' ', ' ', Ix);
      EditGrid1.Cells[0, Iy + 1] := Form1.GetAccountName(ApuS);      // tilin numero ja nimi
      if TiliNode <> nil then EditGrid1.Objects[0, Iy + 1] := TiliNode.Data;  // tilin kokonaissumma
      if EditGrid1.RowCount < (Iy + 3) then EditGrid1.RowCount := Iy + 3;
    end;
    MaxTiliRow := EditNode.Count;
    EditGrid1.TopRow := 1;
    EditBoxStart(False);
  end;
end;

{ tositteen editoinnin lopetus; tarkistetaan ensin summaero }
procedure TForm2.BitBtn1Click(Sender: TObject);
begin
  if MaxTiliRow < 1 then
  begin
    Hide;
    Exit;
  end;  
  ExitCell;
  if not EroFlag
  or (MessageDlg('Summien ero ' + EditEro1.Text + #13' Hyvksytnk?',
    mtError, mbOkCancel, 0) = mrOk)
  then
  begin
    Hide;
    Form1.GetTosite;
  end;
end;

{ tositteen editoinnin peruutus }
procedure TForm2.BitBtn2Click(Sender: TObject);
begin
  Hide;
end;

{ tositteen editointia, vientirivin poisto }
procedure TForm2.DelRow1Click(Sender: TObject);
var
  Ix: Integer;
begin
  with EditGrid1 do
  if (Row > 0) and (Row <= MaxTiliRow) and (Row < RowCount) then
  begin
    if (Row + 1) < RowCount then
    begin
      Dec(MaxTiliRow);
      Rows[Row].Clear;
      for Ix := Row to RowCount - 2 do
      Rows[Ix].Assign(Rows[Ix + 1]);
      Rows[RowCount - 1].Clear;
      RowCount := RowCount - 1;
      GridSumma;
    end;
  end;
end;

procedure TForm2.AddRivi1Click(Sender: TObject);
var
  Ix: Integer;
begin
  with EditGrid1 do
  if (Row > 0) and (Row <= MaxTiliRow) and (Row < RowCount) then
  begin
    if (Row + 1) < RowCount then
    begin
      Inc(MaxTiliRow);
      RowCount := RowCount + 1;
      for Ix := RowCount - 2 downto Row do
      Rows[Ix + 1].Assign(Rows[Ix]);
      Rows[Row].Clear;
      GridSumma;
    end;
  end;
end;

procedure TForm2.RiviUp1Click(Sender: TObject);
var
  ApuRow: TStringList;
begin
  with EditGrid1 do
  if (Row > 1) and (Row < RowCount) then
  begin
    ApuRow := TStringList.Create;
    ApuRow.Assign(Rows[Row-1]);
    Rows[Row-1].Assign(Rows[Row]);
    Rows[Row].Assign(ApuRow);
    ApuRow.Free;
  end;
end;

procedure TForm2.RiviDown1Click(Sender: TObject);
var
  ApuRow: TStringList;
begin
  with EditGrid1 do
  if (Row > 0) and (Row < MaxTiliRow) and ((Row + 1) < RowCount) then
  begin
    ApuRow := TStringList.Create;
    ApuRow.Assign(Rows[Row+1]);
    Rows[Row+1].Assign(Rows[Row]);
    Rows[Row].Assign(ApuRow);
    ApuRow.Free;
  end;
end;



procedure TForm2.FormCreate(Sender: TObject);
var
  Ix: Integer;
begin
  EditGrid1.Cells[0, 0] := 'Tili';
  EditGrid1.Cells[1, 0] := 'Debet  ';
  EditGrid1.Cells[2, 0] := 'Kredit  ';
  Alv1.Items.Assign(VatDropTxts);
  Alv1.Items[0] := '-';
  for Ix := 1 to 13 do VatGrid1.Cells[0, Ix] := VatTexts[Ix];
  VatGrid1.Cells[0, 0] := 'Alv-koodi';
  VatGrid1.ColWidths[0] := 120;
  VatGrid1.ColWidths[1] := 180;
  VatGrid1.ColWidths[2] := 330;
end;

{ tositteen tilinumeron nppinohjauksia }
procedure TForm2.TiliEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ApuI, Curs: Integer;
  SL: TStringList;
begin
  if Length(TiliEdit1.Text) = 0 then Exit;
  Curs := TiliEdit1.SelStart;
  if (Key = VK_BACK) and (Curs > 0) then Dec(Curs);
  if TiliEdit1.Text[1] in ['0'..'9']
  then SL := Accounts1 else SL := AccountNames;
  ApuI := StringIndexL(SL, TiliEdit1.Text);
  if ApuI < 0 then
  ApuI := StringIndexL(SL, Copy(TiliEdit1.Text, 1, Curs));
  if ApuI >= 0
  then TiliEdit1.Text := SL[ApuI]
  else if Curs > 0 then Dec(Curs);
  TiliEdit1.SelStart := Curs;
  TiliEdit1.SelLength := Length(TiliEdit1.Text) - Curs;
  Alv1.Items.Assign(VatDropTxts);
end;


procedure TForm2.TiliEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  Char(VK_ESCAPE):
    begin
      Key := #0;
      TiliEdit1.Text := EditGrid1.Cells[EditGrid1.Col, EditGrid1.Row];
      TiliEdit1.SelStart := 0;
      TiliEdit1.SelLength := Length(TiliEdit1.Text);
    end;
  Tab, Char(VK_RETURN):
    begin
      Key := #0;
      TiliEdit1Exit(Sender);
    end;
  end;
end;

procedure TForm2.TiliEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key in [VK_LEFT, VK_RIGHT] then      //, VK_BACK
    TiliEdit1.SelLength := 0;
end;

procedure TForm2.TiliEdit1Enter(Sender: TObject);
begin
  if TiliEdit1.Visible then
  with EditGrid1 do
  begin
    DisableAlign;
    Row := TiliEdit1.Tag;
    Col := 0;
    EnableAlign;
  end;
end;

{ tilinumeroiden drop down -lista}
procedure TForm2.TiliEdit1DropDown(Sender: TObject);
var
  Ix, Ip: Integer;
  SL: TStringList;
begin
  Ip := TiliEdit1.SelStart;
  if Ip = 0
  then TiliEdit1.Items.Assign(Accounts1)
  else
  begin
    if TiliEdit1.Text[1] in ['0'..'9']
    then SL := Accounts1
    else SL := AccountNames;
    {  Iq := NumLength(TiliEdit1.Text);
      if Ip > Iq then Ip := Iq;   }
    TiliEdit1.Items.Clear;
    if (SL.Count > 0) and (Length(TiliEdit1.Text) > 0) and (Ip > 0) then
    for Ix := 0 to SL.Count - 1 do
    if (AnsiStrLComp(PChar(SL[Ix]), PChar(TiliEdit1.Text), Ip) = 0)
    then TiliEdit1.Items.Add(SL[Ix]);
  end;
end;

procedure TForm2.TiliEdit1Exit(Sender: TObject);
var
  ApuI, Ix: Integer;
begin
  if TiliEditKesken then Exit;
  if (Length(TiliEdit1.Text) = 0) then
  begin
    DelRow1Click(Sender);  // poistetaan rivi
    with EditGrid1 do
    TiliEdit1.Text := Cells[0, Row];
    Exit;
  end;
  TiliEditKesken := True;
  if (Length(TiliEdit1.Text) > 0) and (TiliEdit1.Text[1] in ['0'..'9'])
  then ApuI := StringIndexL(Accounts1, TiliEdit1.Text)
  else
  begin  // etsitn merkkijonon lopussa olevan tilinumeron mukaan
    Ix := Length(TiliEdit1.Text);
    while (Ix > 0) and (TiliEdit1.Text[Ix] in ['0'..'9']) do Dec(Ix);
    ApuI := StringIndexL(Accounts1, Copy(TiliEdit1.Text, Ix + 1, Length(TiliEdit1.Text) - Ix));
  end;
  if ApuI >= 0 then
  begin
    TiliEdit1.Text := Accounts1[ApuI];
    if MaxTiliRow < EditGrid1.Row then MaxTiliRow := EditGrid1.Row;
    if EditGrid1.RowCount < (MaxTiliRow + 2) then EditGrid1.RowCount := MaxTiliRow + 2;
    // EditGrid1.Cells[EditGrid1.Col, EditGrid1.Row] := TiliEdit1.Text;
    if (Length(TiliEdit1.Text) >= 6) and (TiliEdit1.Text[6] = '@') then
    begin  { voittotilin kirjaus, haetaan ajan tasalla oleva voitto }
      if DirtyFlag and $8000 <> 0 then Form1.TeeAccountList1;
      if DirtyFlag and 8 <> 0 then Form1.OpenTulosTase(True);
      ApuI := -Voitto;
    end
    else ApuI := EditEro1.Tag;
    with EditGrid1 do
    begin
      if ApuI >= 0 then Col := 1 else Col := 2;
      if (ApuI <> 0) and (Length(Cells[Col, Row]) = 0) and (Length(Cells[Col xor 3, Row]) = 0) then
      begin
        Cells[Col, Row] := Format('%.2f', [Abs(ApuI/100)]);
        GridSumma;
      end;
      if Row > MaxTiliRow then MaxTiliRow := Row;
    end;
  end;
  TiliEditKesken := False;
end;

{ tili editoitu, siirretn  }
procedure TForm2.Ok4Click(Sender: TObject);
var
  Ix: Integer;
  ApuS: String;
  ApuNode: TTreeNode;
begin
  Ix := StrToIntDef(TiliNro2.Text, 0);
//  if (Ix < 1000) or (Ix > 10000) then Ix := -1;
  ApuS := IntToStr(Ix);
  if (Ix > 0) and (Accounts1.IndexOf(ApuS) >= 0) then
  begin       { Tilinumero on jo kytss }
    ShowMessage('Tilinumero ' + ApuS + ' on jo kytss');
    Exit;
  end;
  { siirretn tiedot ensin ptaulukkoon, sitten sielt Tilikarttaan }
  Hide;
  if EditNode.Data = nil then Exit;
  ApuNode := EditNode.Data;   { ApuNode = ptaulukon node }
  if UusiAlatili then
  begin
    if (ApuNode.Count > 0) and (Length(ApuNode[0].Text) = 0)
    then ApuNode := ApuNode[0]                             // on jo tyhj node
    else ApuNode := Form1.TreeView1.Items.AddChild(ApuNode, ''); // uusi tyhj node
    ApuNode := Form1.TreeView1.Items.AddChild(ApuNode, '');      // sen alanodeksi uusi node
    EditNode := Form1.Tilikartta.Items.AddChild(EditNode, '');
  end;
  ApuNode.Text := AccountTxt + ' ' + ApuS + ' "' + TiliNimi2.Text + '"';
  if ApuNode.Count = 0 then Form1.TreeView1.Items.AddChild(ApuNode, '');
  if Ix > 0 then
  begin
    while ApuNode.Count > 1 do ApuNode[ApuNode.Count-1].Delete;                // poistetaan mahdolliset alv-koodit
    if Alv1.ItemIndex > 0 then
    begin                                     // alv-kooditilit
      ApuS := 'vat ' + VatGrid1.Cells[0, Alv1.ItemIndex];
      if Alv1.ItemIndex in [1..3] then        // alv-% vain myynti-, myynnin alv- ja ostotileille
      ApuS := ApuS + ' ' + IntToStr(SumTxtToInt(AlvPros1.Text));
      Form1.TreeView1.Items.AddChild(ApuNode, ApuS);  // alv-koodi
    end;
  end;
  Form1.TeeTili(ApuNode, EditNode);
  Muuttunut := True;
  DirtyFlag := $FFFF;
end;

procedure TForm2.Cancel4Click(Sender: TObject);
begin
  Hide;
end;

procedure TForm2.BitBtn3Click(Sender: TObject);
begin
  VatDropTxts.Assign(VatGrid1.Cols[1]);
  VatListTxts.Assign(VatGrid1.Cols[2]);
  Alv1.Items.Assign(VatGrid1.Cols[1]);
  Alv1.Items[0] := '-';
  VahVeroTxt := VahVero2.Text;
  MaksVeroTxt := MaksVero2.Text;
  Form1.WriteIni;
  Hide;
end;

procedure TForm2.BitBtn4Click(Sender: TObject);
begin
  Hide;
end;

procedure TForm2.Alv1Change(Sender: TObject);
begin
  AlvPros1.Enabled := Alv1.ItemIndex in [1..3];
  if not AlvPros1.Enabled then AlvPros1.Text := '';
end;

end.
